#!/bin/bash

SRC=$1
DIR=$2
MAX_EPOCH=$3
SAVE_INTERVAL=$4

cd $DIR

if [ "$FAIRSEQ" = "" ]; then
  echo "you must set environment variable FAIRSEQ to fairseq github directory!"
  exit
fi

python $FAIRSEQ/train.py \
    data-bin/ \
    --source-lang $SRC --target-lang en \
    --arch transformer --share-all-embeddings \
    --encoder-layers 5 --decoder-layers 5 \
    --encoder-embed-dim 512 --decoder-embed-dim 512 \
    --encoder-ffn-embed-dim 2048 --decoder-ffn-embed-dim 2048 \
    --encoder-attention-heads 2 --decoder-attention-heads 2 \
    --encoder-normalize-before --decoder-normalize-before \
    --dropout 0.4 --attention-dropout 0.2 --relu-dropout 0.2 \
    --weight-decay 0.0001 \
    --label-smoothing 0.2 --criterion label_smoothed_cross_entropy \
    --optimizer adam --adam-betas '(0.9, 0.98)' --clip-norm 0 \
    --lr-scheduler inverse_sqrt --warmup-updates 4000 --warmup-init-lr 1e-7 \
    --lr 1e-3 --min-lr 1e-9 \
    --max-tokens 4000 \
    --update-freq 4 \
    --max-epoch $MAX_EPOCH --save-interval $SAVE_INTERVAL
